# config.pl
# == Author(s) : Takuya Otani <takuya.otani@gmail.com> ==
# == Copyright (C) 2005 SimpleBoxes/SerendipityNZ Ltd. ==

package sb::Config;
sub setting
{
	return (
		# -- database settings : base
		'driver'   => 'Unknown',
		'db_param' => {},
		# -- database settings : MySQL
# 		'driver'   => 'Mysql',
# 		'db_param' => {
# 			'user' => 'root',
# 			'pass' => 'password',
# 			'name' => 'serenebach',
# 			'host' => 'localhost',
# 			'port' => 3306,
# 			'sock' => undef,
# 		},
		# -- database settings : Sqlite 
# 		'driver'   => 'Sqlite',
# 		'db_param' => {
# 			'name'    => './data/sqlite/data.db',
# 			'sqlite2' => undef,
# 		},
		# -- database settings : Text
# 		'driver'   => 'Text',
# 		'db_param' => {
# 			'name'       => './data/text/',
# 			'suffix'     => '.cgi',
# 			'index'      => 'id',
# 			'permission' => 0666,
# 			'lock_file'  => 'save',
# 			'tmp_file'   => '_tmp',
# 			'unit'       => 100,
# 		},
		# --- database setting : TextOld
# 		'driver'   => 'TextOld',
# 		'db_param' => {
# 			'dir' => './data/old/',
# 			'suf' => '.cgi',
# 			'idx'  => 'id',
# 			'mod'  => 0666,
# 			'lock' => 'save',
# 		},
		# default settings
		'max_data'      => 15360000,   # acceptable maximum upload size / 15360000 byte = 15MB
		'language'      => 'ja',       # language for string / character set
		'local'         => 'jp',       # local
		'language_ext'  => '.txt',     # string resource extension
		'init_file'     => 'init.cgi', # configuration file
		'init_loaded'   => 0,          # modified date for init_file
		'debug_content' => 0,          # content debug flag
		'debug_level'   => 0,          # general debug output flag
		'last_update'   => 0,          # modified date of a configure file
		# path
		'resource_dir' => 'lib/resource/',
		'site_css'     => '',
		'server_path'  => 'http://127.0.0.1/',
		# Global configuration
		'basic_base_enc'     => 1026,          # buffer size for base64 encoding [should be in multiples of 54]
		'basic_preid'        => 'eid',         # prefix for article id
		'basic_suffix'       => '.html',       # extension for static log file
		'basic_marking'      => 1,             # article marking flag in log
		'basic_gen_atom'     => 10,            # number of articles in Atom feed
		'basic_gen_rss'      => 10,            # number of articles in RSS feed
		'basic_id'           => '',            # weblog id for multiple weblogs
		'basic_sb'           => 'sb.cgi',      # script name for Serene Bach (main script)
		'basic_tb'           => '',            # script name for trackback entry point
		'basic_feed'         => '',            # script name for feed output
		'basic_rsd'          => '',            # script name for RSD (Really Simple Discoverability)
		'basic_xmlrpc'       => 'admin.cgi',   # script name for XMP-RPC API entry point
		'basic_admn'         => 'admin.cgi',   # script name for weblog management
		'basic_cnt'          => 'cnt.cgi',     # script name for access logger
		'basic_mob'          => 'mb.cgi',      # script name for access point of mobile terminal
		'basic_install'      => 'install.cgi', # script name for installer / converter
		'basic_buildnum'     => 50,            # number of articles which are rebuilt at once
		'basic_mailsize'     => 102400,        # acceptable mail size / 102400 byte = 100KB
		'basic_cooktag'      => 'sbviewer',    # identifier for cookie in main script
		'basic_admntag'      => 'sbadmin',     # identifier for cookie in management script
		'basic_logtag'       => 'sblog',       # identifier for cookie in access logger
		'basic_sessiontag'   => 'sb_session',  # identifier for cookie in session of management script
		'basic_cookiekey'    => 'on',          # value in cookie for main script
		'basic_admn_expire'  => 1,             # vilid duration of login for management script / 1 day
		'basic_max_img'      => 10,            # maxmum number of files which are uploaded at once
		'basic_img_chck'     => 0,             # binding option between uploaded files and articles
		'basic_http_proxy'   => '',            # http proxy for sending pings
		'basic_com_format'   => 2,             # comment text format
		'basic_ref_check'    => 1,             # referer check flag for management script
		'basic_temp_conv'    => 1,             # character set converter for resource
		'basic_xmlpublish'   => 0,             # publishment flag via XML-RPC
		'basic_file_attr'    => 0666,          # default file permission
		'basic_dir_attr'     => 0777,          # default directory permission
		'basic_min_update'   => 30,            # minimum update period / 30 mins
		'basic_use_ajax'     => 1,             # ajax rebuilding flag
		'basic_oldrebuild'   => 0,             # using old style build, it's exclusive relationship with use_ajax
		'basic_build_ajax'   => 20,            # number of articles which are rebuilt at once via ajax
		'basic_warn_init'    => 1,             # displaying warning for init.cgi status
		'basic_aws_locale'   => 'jp',          # AWS locale
		'basic_cookie'       => ['email','url','name','icon','checkid'], # values which are stored in cookie
		'basic_mobswitch'    => 'ASTEL|UP\.Browser|KDDI|PDXGW|DoCoMo|J\-PHONE|L\-mode|DDIPOCKET|WILLCOM|Vodafone|SoftBank',
		# Weblog configuration
		'conf_entry_disp'     => 10,
		'conf_com_disp'       => 10,
		'conf_tb_disp'        => 10,
		'conf_newent_disp'    => 5,
		'conf_aws_disp'       => 5,
		'conf_page_disp'      => 1,
		'conf_search_disp'    => 1,
		'conf_entry_sort'     => 1,
		'conf_archive_sort'   => 1,
		'conf_com_sort'       => 1,
		'conf_tb_sort'        => 1,
		'conf_timezone'       => '+0900',
		'conf_thumbsize'      => 120,
		'conf_thumbcheck'     => 0,
		'conf_imagename'      => 0,
		'conf_srv_cgi'        => '',
		'conf_srv_base'       => '',
		'conf_dir_base'       => './',
		'conf_dir_log'        => 'log/',
		'conf_dir_img'        => 'img/',
		'conf_lang'           => 'ja',
		'conf_entry_archive'  => 'Individual',
		'conf_ip_ban'         => "",
		'conf_edit_ping'      => "http://ping.rss.drecom.jp/\nhttp://ping.bloggers.jp/rpc/\nhttp://www.blogpeople.net/servlet/weblogUpdates\nhttp://serenebach.net/rep.cgi\n",
		'conf_archive_temp'   => -1,
		'conf_profile_temp'   => -1,
		'conf_mobile_temp'    => -1,
		'conf_css_change'     => 0,
		'conf_spamlevel'      => 0,
		'conf_spamid'         => 'sbSpamBlock',
		'conf_spamword'       => "name=poker\nname=slot\nname=diet\nname=penis\nname=pills\nname=merchant account\nname=tramadol\nname=ambien\nname=cialis\nname=Briana\nname=Buy\nname=buy\nname=fioricet\nname=levitra\nname=black jack\nname=texas\nname=viagra\nname=casino",
		'conf_spamstat'       => 0,
		'conf_spamtb'         => 0,
		'conf_spamtblevel'    => 0,
		'conf_spamtbword'     => '',
		'conf_spamtbstat'     => 0,
		'conf_entry_date'     => '%Year%.%Mon%.%Day% %WeekLong%',
		'conf_entry_time'     => '%Hour%:%Min%',
		'conf_msg_time'       => '%Year%/%Mon%/%Day% %Hour12%:%Min% %HourAP%',
		'conf_dateinlist'     => ' (%Mon%/%Day%)',
		'conf_archivelist'    => '%MonLong% %Year%',
		'conf_time_lang'      => 'en',
		'conf_dbtype'         => 'Text',
		'conf_checklog'       => 30,
		# Extra settings from Serene Bach 3
		'conf_hidenum_archive'  => 0,
		'conf_hidenum_category' => 0,
		'sb2_charcode'        => 'euc',
		# Settings for array
		'setup_lang'          => ['ja',],
		'setup_entry_archive' => ['Individual','Monthly','None',],
		'setup_debug_ping'    => 'serenebach.net/',
		'setup_tz_hour'       => [
			'+13','+12','+11','+10','+09','+08','+07','+06','+05','+04','+03','+02','+01',
			'+00','-01','-02','-03','-04','-05','-06','-07','-08','-09','-10','-11','-12',
		],
		'setup_tz_min'        => ['00','30','45',],
		# Settings for servers
		'srv_doc'  => './doc/',
		'srv_temp' => 'resource/',
		# Settings for directories
		'dir_style'  => 'template/',
		'dir_temp'   => './lib/resource/',
		'dir_rsrc'   => './resource/',
		'dir_plugin' => './plugin/',
		'dir_lock'   => './lock/',
		'dir_data'   => './data/',
		'dir_access' => 'log/',
		# Settings for files
		'file_index'  => 'index.html', # in base
		'file_css'    => 'style.css',  # in base
		'file_rss'    => 'index.rdf',  # in log
		'file_atom'   => 'atom.xml',   # in log
		'file_conf'   => 'configure.cgi',
		'file_cook'   => 'cookie.js',
		'file_logjs'  => 'cnt.js',
		'file_lock'   => 'lock',
		'file_lckcnt' => 'cnt',
		'file_access' => 'log.cgi',
		'file_suf'    => '.cgi',
		# Settings for sb::Driver::TextOld
		'dbtxt_data' => './data/',
		'dbtxt_save' => 'save',
		'dbtxt_ids'  => 'id',
	);
}
sub saved_key
{
	my $self = shift;
	my $key = shift;
	return if ($key !~ /^conf_/);
	return $key;
}
sub check_key
{
	my $self = shift;
	my $key = shift;
	my %alias_of = (
		'DataDir'                => 'dir_data',
		'DataSuffix'             => 'file_suf',
		'LockDir'                => 'dir_lock',
		'TempDir'                => 'dir_temp',
		'PluginDir'              => 'dir_plugin',
		'StyleDir'               => 'dir_style',
		'ResourceDir'            => 'dir_rsrc',
		'HelpSrv'                => 'srv_doc',
		'TempSrv'                => 'srv_temp',
		'TopIndex'               => 'file_index',
		'TempConv'               => 'basic_temp_conv',
		'HttpProxy'              => 'basic_http_proxy',
		'AdminCookieDay'         => 'basic_admn_expire',
		'RefCheck'               => 'basic_ref_check',
		'WeblogId'               => 'basic_id',
		'MainScript'             => 'basic_sb',
		'FeedScript'             => 'basic_feed',
		'TrackbackReceiver'      => 'basic_tb',
		'XmlrpcEntryPoint'       => 'basic_xmlrpc',
		'XmlrpcForcedPublish'    => 'basic_xmlpublish',
		'StaticFileSuffix'       => 'basic_suffix',
		'OldStyleRebuilding'     => 'basic_oldrebuild',
		'AmazonWebServiceLocale' => 'basic_aws_locale',
		'MobileRegex'            => 'basic_mobswitch',
		'ScriptPath'             => 'conf_srv_cgi',
		'BaseDir'                => 'conf_dir_base',
		'BaseSrv'                => 'conf_srv_base',
		'LogDir'                 => 'conf_dir_log',
		'ImgDir'                 => 'conf_dir_img',
		'SpamCheckLevel'         => 'conf_spamlevel',
		'SpamCheckId'            => 'conf_spamid',
		'InitLanguage'           => 'conf_lang',
		'HideNumInArchiveList'   => 'conf_hidenum_archive',
		'HideNumInCategoryTree'  => 'conf_hidenum_category',
	);
	return $alias_of{$key} if (defined($alias_of{$key}));
	return $key;
}
sub verify_values
{
	my $self = shift;
	my %type_of = (
		'dir_data'          => '_dir',
		'dir_lock'          => '_dir',
		'dir_temp'          => '_dir',
		'dir_rsrc'          => '_dir',
		'dir_plugin'        => '_dir',
		'resource_dir'      => '_dir',
		'srv_doc'           => '_dir',
		'srv_temp'          => '_dir',
		'conf_srv_cgi'      => '_dir',
		'conf_dir_base'     => '_dir',
		'conf_srv_base'     => '_dir',
		'conf_dir_log'      => '_dir',
		'conf_dir_img'      => '_dir',
		'file_suf'          => '_ext',
		'basic_suffix'      => '_ext',
		'basic_xmlpublish'  => '_int',
		'basic_temp_conv'   => '_int',
		'basic_admn_expire' => '_int',
		'basic_ref_check'   => '_int',
		'conf_spamlevel'    => '_int',
		'basic_id'          => 0,
		'basic_aws_locale'  => 0,
		'conf_lang'         => 0,
		'basic_use_ajax'    => 0,
	);
	foreach my $key ( keys %type_of )
	{
		my $type = $type_of{$key};
		if ($type eq '_dir')
		{
			$self->{$key} .= '/' if ($self->{$key} !~ /\/$/);
		}
		elsif ($type eq '_ext')
		{
			$self->{$key} = '.' . $self->{$key} if ($self->{$key} !~ /^\./);
		}
		elsif ($type eq '_int')
		{
			$self->{$key} = int($self->{$key});
		}
		elsif ($key eq 'basic_id' and $self->{$key} =~ /\w+/)
		{
			my $value = $self->{$key};
			if ( $self->{'basic_cooktag'} !~ /\Q$value\E$/ )
			{
				$self->{'basic_cooktag'}    .= $value;
				$self->{'basic_admntag'}    .= $value;
				$self->{'basic_logtag'}     .= $value;
				$self->{'basic_sessiontag'} .= $value;
			}
		}
		elsif ($key eq 'basic_aws_locale')
		{
			$self->{$key} = 'jp' if ($self->{$key} !~ /\w\w/);
		}
		elsif ($key eq 'conf_lang')
		{
			$self->{$key} = 'ja' if ($self->{$key} !~ /\w\w/);
			$self->{'language'} = $self->{$key};
		}
		elsif ($key eq 'basic_use_ajax')
		{
			$self->{$key} = 0 if ( $self->{'basic_oldrebuild'} eq '1' );
		}
	} # end of foreach my $key ( keys %type_of )
	# set default value if the value is empty
	$self->{'basic_tb'}      = $self->{'basic_sb'} if ($self->{'basic_tb'} eq '');
	$self->{'basic_feed'}    = $self->{'basic_sb'} . '?feed=' if ($self->{'basic_feed'} eq '');
	$self->{'basic_rsd'}     = $self->{'basic_sb'} . '?rsd=on' if ($self->{'basic_rsd'} eq '');
	$self->{'conf_srv_cgi'}  = './' if ($self->{'conf_srv_cgi'} eq '/' or $self->{'conf_srv_cgi'} eq '');
	$self->{'conf_srv_base'} = $self->{'conf_srv_cgi'} if ($self->{'conf_srv_base'} eq '/' or $self->{'conf_srv_base'} eq '');
	$self->{'srv_temp'}      = $self->{'conf_srv_base'} . 'resource/' if ($self->{'srv_temp'} eq '/' or $self->{'srv_temp'} eq '');
}
1;
__END__
